package cn.newfeifan.mall.module.system.service.config;

import cn.newfeifan.mall.framework.common.pojo.PageResult;
import cn.newfeifan.mall.module.system.controller.admin.config.vo.ConfigPageReqVO;
import cn.newfeifan.mall.module.system.controller.admin.config.vo.ConfigSaveReqVO;
import cn.newfeifan.mall.module.system.dal.dataobject.config.SystemConfigDO;

import javax.validation.Valid;

/**
 * 系统配置 Service 接口
 *
 * @author 非繁人
 */
public interface SystemConfigService {

    /**
     * 创建系统配置
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createConfig(@Valid ConfigSaveReqVO createReqVO);

    /**
     * 更新系统配置
     *
     * @param updateReqVO 更新信息
     */
    void updateConfig(@Valid ConfigSaveReqVO updateReqVO);

    /**
     * 删除系统配置
     *
     * @param id 编号
     */
    void deleteConfig(Long id);

    /**
     * 获得系统配置
     *
     * @param id 编号
     * @return 系统配置
     */
    SystemConfigDO getConfig(Long id);

    /**
     * 获取系统配置
     * @return 系统配置
     */
    SystemConfigDO getConfig();

    /**
     * 获取常量系统配置
     * @return 系统配置
     */
    SystemConfigDO getRedisConfig();

    /**
     * 获得系统配置分页
     *
     * @param pageReqVO 分页查询
     * @return 系统配置分页
     */
    PageResult<SystemConfigDO> getConfigPage(ConfigPageReqVO pageReqVO);

}
